/**
 * RWD Table with freezing head and columns for jQuery
 * 
 * @author  Nick Tsai <myintaer@gmail.com>
 * @version 1.2.0
 * @see     https://github.com/yidas/jquery-freeze-table
 */
!function(e,i){"use strict";var t=function(i,t){return this.$tableWrapper=e(i).first(),this.options=t||{},this.namespace=this.options.namespace||"freeze-table",this.callback,this.scrollBarHeight,this.shadow,this.fastMode,this.backgroundColor,this.scrollable,this.$table=this.$tableWrapper.children("table"),this.$container,this.$headTableWrap,this.$columnTableWrap,this.$columnHeadTableWrap,this.$scrollBarWrap,this.fixedNavbarHeight,this.isWindowScrollX=!1,this.headWrapClass="clone-head-table-wrap",this.columnWrapClass="clone-column-table-wrap",this.columnHeadWrapClass="clone-column-head-table-wrap",this.scrollBarWrapClass="clone-scroll-bar-wrap",this.init(),this};t.prototype.init=function(){if(!this.$table.length)throw"The element must contain a table dom";if("update"===this.options)this.destroy(),this.options=this.$tableWrapper.data("freeze-table-data");else{if("resize"===this.options)return this.options=this.$tableWrapper.data("freeze-table-data"),this.namespace=this.options.namespace||this.namespace,void this.resize();this.$tableWrapper.data("freeze-table-data",this.options)}var t=this.options,s=void 0===t.freezeHead||t.freezeHead,a=void 0===t.freezeColumn||t.freezeColumn,l=void 0===t.freezeColumnHead||t.freezeColumnHead,r=void 0!==t.scrollBar&&t.scrollBar,o=t.fixedNavbar||".navbar-fixed-top",n=t.callback||null;this.namespace=this.options.namespace||this.namespace,this.scrollBarHeight=e.isNumeric(t.scrollBarHeight)?t.scrollBarHeight:i.innerWidth-document.documentElement.clientWidth,this.shadow=void 0!==t.shadow&&t.shadow,this.fastMode=void 0!==t.fastMode&&t.fastMode,this.backgroundColor=void 0!==t.backgroundColor?t.backgroundColor:"white",this.scrollable=void 0!==t.scrollable&&t.scrollable,this.fixedNavbarHeight=o&&e(o).outerHeight()||0,this.$container=void 0!==t.container&&t.container&&e(t.container).length?e(t.container):e(i),this.isInit()&&this.destroy(),this.scrollable||this.$tableWrapper.css("height","100%").css("min-height","100%").css("max-height","100%"),s&&this.buildHeadTable(),a&&(this.buildColumnTable(),this.$tableWrapper.css("overflow-x","scroll")),l&&s&&a&&this.buildColumnHeadTable(),r&&this.buildScrollBar();var h=function(){this.$container.scrollLeft()>0?(this.isWindowScrollX=!0,this.$headTableWrap&&this.$headTableWrap.css("visibility","hidden"),this.$columnTableWrap&&this.$columnTableWrap.css("visibility","hidden"),this.$columnHeadTableWrap&&this.$columnHeadTableWrap.css("visibility","hidden"),this.$scrollBarWrap&&this.$scrollBarWrap.css("visibility","hidden")):this.isWindowScrollX=!1}.bind(this);this.$container.on("scroll."+this.namespace,function(){h()}),this.resize(),"function"==typeof n&&n()},t.prototype.buildHeadTable=function(){var t=this,s=this.clone(this.$table);if(this.fastMode)s=this.simplifyHead(s);var a=this.options.headWrapStyles||null;if(this.$headTableWrap=e('<div class="'+this.headWrapClass+'"></div>').append(s).css("position","fixed").css("overflow","hidden").css("visibility","hidden").css("top",0+this.fixedNavbarHeight).css("z-index",2),this.shadow&&this.$headTableWrap.css("box-shadow","0px 6px 10px -5px rgba(159, 159, 160, 0.8)"),a&&"object"==typeof a&&e.each(a,function(e,i){t.$headTableWrap.css(e,i)}),this.$tableWrapper.append(this.$headTableWrap),this.$tableWrapper.on("scroll."+this.namespace,function(){t.$headTableWrap.scrollLeft(e(this).scrollLeft())}),this.scrollable){var l=function(e,i){var t=i.$tableWrapper.offset().top;i.$tableWrapper.scrollTop()>0&&t>i.fixedNavbarHeight?(i.$headTableWrap.offset({top:t}),i.$headTableWrap.css("visibility","visible")):i.$headTableWrap.css("visibility","hidden")};this.$tableWrapper.on("scroll."+this.namespace,function(){l(0,t)}),this.$container.on("scroll."+this.namespace,function(){l(0,t)})}else e.isWindow(t.$container.get(0))?this.$container.on("scroll."+this.namespace,function(){var e=t.$container.scrollTop()+t.fixedNavbarHeight,i=t.$table.offset().top-1;i-1<=e&&i+t.$table.outerHeight()-1>=e?t.$headTableWrap.css("visibility","visible"):t.$headTableWrap.css("visibility","hidden")}):this.$container.on("scroll."+this.namespace,function(){var s=e(i).scrollTop(),a=t.$table.offset().top-1;a<=s&&a+t.$table.outerHeight()-1>=s?(t.$headTableWrap.offset({top:s}),t.$headTableWrap.css("visibility","visible")):t.$headTableWrap.css("visibility","hidden")});this.$container.on("resize."+this.namespace,function(){var e=t.scrollable?t.$tableWrapper.width()-t.scrollBarHeight:t.$tableWrapper.width();e=e>0?e:t.$tableWrapper.width(),t.$headTableWrap.css("width",e),t.$headTableWrap.css("height",t.$table.find("thead").outerHeight())})},t.prototype.buildColumnTable=function(){var i=this,t=this.options.columnWrapStyles||null,s=this.options.columnNum||1,a=void 0!==this.options.columnKeep&&this.options.columnKeep,l=this.shadow?0:1,r=void 0!==this.options.columnBorderWidth?this.options.columnBorderWidth:l,o=this.clone(this.$table);if(this.$columnTableWrap=e('<div class="'+this.columnWrapClass+'"></div>').append(o).css("position","fixed").css("overflow","hidden").css("visibility","hidden").css("z-index",1),this.shadow&&this.$columnTableWrap.css("box-shadow","6px 0px 10px -5px rgba(159, 159, 160, 0.8)"),t&&"object"==typeof t&&e.each(t,function(e,t){i.$columnTableWrap.css(e,t)}),this.scrollable){var n=this.$tableWrapper.height()-this.scrollBarHeight;n=n>0?n:this.$tableWrapper.height(),this.$columnTableWrap.height(n)}this.$tableWrapper.append(this.$columnTableWrap);var h=function(){i.$columnTableWrap.offset({top:i.$tableWrapper.offset().top})};a?this.$columnTableWrap.css("visibility","visible"):i.scrollable?this.$tableWrapper.on("scroll."+this.namespace,function(){e(this).scrollLeft()>0?(i.$columnTableWrap.scrollTop(i.$tableWrapper.scrollTop()),i.$columnTableWrap.css("visibility","visible")):i.$columnTableWrap.css("visibility","hidden")}):this.$tableWrapper.on("scroll."+this.namespace,function(){i.isWindowScrollX||(e(this).scrollLeft()>0?i.$columnTableWrap.css("visibility","visible"):i.$columnTableWrap.css("visibility","hidden"))}),this.$container.on("resize."+this.namespace,function(){o.width(i.$table.width());for(var e=0+r,t=1;t<=s;t++){var a=i.$table.find("th:nth-child("+t+")").outerWidth();e+=a>0?a:i.$table.find("td:nth-child("+t+")").outerWidth()}i.$columnTableWrap.width(e),h()}),this.$container.on("scroll."+this.namespace,function(){h()})},t.prototype.buildColumnHeadTable=function(){var t=this;this.$columnHeadTableWrap=this.clone(this.$headTableWrap),this.fastMode&&(this.$columnHeadTableWrap=this.simplifyHead(this.$columnHeadTableWrap));var s=this.options.columnHeadWrapStyles||null;if(this.$columnHeadTableWrap.removeClass(this.namespace).addClass(this.columnHeadWrapClass).css("z-index",3),this.shadow&&this.$columnHeadTableWrap.css("box-shadow","none"),s&&"object"==typeof s&&e.each(s,function(e,i){this.$columnHeadTableWrap.css(e,i)}),this.$tableWrapper.append(this.$columnHeadTableWrap),this.scrollable){var a=function(){var e=t.$tableWrapper.offset().top;t.$tableWrapper.scrollTop()>0&&e>t.fixedNavbarHeight?(t.$columnHeadTableWrap.offset({top:e}),t.$columnHeadTableWrap.css("visibility","visible")):t.$columnHeadTableWrap.css("visibility","hidden")};e(this.$tableWrapper).on("scroll."+this.namespace,function(){a()})}else if(e.isWindow(this.$container.get(0)))a=function(){var e=t.$container.scrollTop()+t.fixedNavbarHeight,i=t.$table.offset().top-1;i-1<=e&&i+t.$table.outerHeight()-1>=e&&t.$tableWrapper.scrollLeft()>0?t.$columnHeadTableWrap.css("visibility","visible"):t.$columnHeadTableWrap.css("visibility","hidden")};else a=function(){var s=e(i).scrollTop(),a=t.$table.offset().top-1;a<=s&&a+t.$table.outerHeight()-1>=s&&t.$tableWrapper.scrollLeft()>0?(t.$columnHeadTableWrap.offset({top:s}),t.$columnHeadTableWrap.css("visibility","visible")):t.$columnHeadTableWrap.css("visibility","hidden")};this.$container.on("scroll."+this.namespace,function(){a()}),this.$tableWrapper.on("scroll."+this.namespace,function(){t.isWindowScrollX||a()}),this.$container.on("resize."+this.namespace,function(){t.$columnHeadTableWrap.find("> table").css("width",t.$table.width()),t.$columnHeadTableWrap.css("width",t.$columnTableWrap.width()),t.$columnHeadTableWrap.css("height",t.$table.find("thead").outerHeight())})},t.prototype.buildScrollBar=function(){var i=this,t=this.$table.find("thead").outerHeight(),s=e('<div class="'+this.scrollBarWrapClass+'"></div>').css("width",this.$table.width()).css("height",1);this.$scrollBarWrap=e('<div class="'+this.scrollBarWrapClass+'"></div>').css("position","fixed").css("overflow-x","scroll").css("visibility","hidden").css("bottom",0).css("z-index",2).css("width",this.$tableWrapper.width()).css("height",this.scrollBarHeight),this.$scrollBarWrap.append(s),this.$tableWrapper.append(this.$scrollBarWrap),this.$scrollBarWrap.on("scroll."+this.namespace,function(){i.$tableWrapper.scrollLeft(e(this).scrollLeft())}),this.$tableWrapper.on("scroll."+this.namespace,function(){i.$scrollBarWrap.scrollLeft(e(this).scrollLeft())}),this.$container.on("scroll."+this.namespace,function(){var e=i.$container.scrollTop()+i.$container.height()-t+i.fixedNavbarHeight;i.$table.offset().top-1<=e&&i.$table.offset().top+i.$table.outerHeight()-1>=e?i.$scrollBarWrap.css("visibility","visible"):i.$scrollBarWrap.css("visibility","hidden")}),this.$container.on("resize."+this.namespace,function(){s.css("width",i.$table.width()),i.$scrollBarWrap.css("width",i.$tableWrapper.width())})},t.prototype.clone=function(i){var t=e(i).clone().removeAttr("id");return this.backgroundColor&&t.css("background-color",this.backgroundColor),t},t.prototype.simplifyHead=function(i){var t=this,s=e(i);return s.find("> tr, > tbody, > tfoot").remove(),e.each(s.find("> thead > tr:nth-child(1) >"),function(i,s){var a=t.$table.find("> thead > tr:nth-child(1) > :nth-child("+parseInt(i+1)+")").outerWidth();e(this).css("width",a)}),s},t.prototype.isInit=function(){return!!this.$tableWrapper.find("."+this.headWrapClass).length||(!!this.$tableWrapper.find("."+this.columnWrapClass).length||(!!this.$tableWrapper.find("."+this.columnHeadWrapClass).length||!!this.$tableWrapper.find("."+this.scrollBarWrapClass).length))},t.prototype.unbind=function(){this.$container.off("resize."+this.namespace),this.$container.off("scroll."+this.namespace),this.$tableWrapper.off("scroll."+this.namespace)},t.prototype.destroy=function(){this.unbind(),this.$tableWrapper.find("."+this.headWrapClass).remove(),this.$tableWrapper.find("."+this.columnWrapClass).remove(),this.$tableWrapper.find("."+this.columnHeadWrapClass).remove(),this.$tableWrapper.find("."+this.scrollBarWrapClass).remove()},t.prototype.resize=function(){return this.$container.trigger("resize."+this.namespace),this.$container.trigger("scroll."+this.namespace),this.$tableWrapper.trigger("scroll."+this.namespace),!0},t.prototype.update=function(){return this.options="update",this.init(),this},i.FreezeTable=t,e.fn.freezeTable=function(e){if(1===this.length)return new t(this,e);if(this.length>1){var i=[];return this.each(function(){i.push(new t(this,e))}),i}return!1}}(jQuery,window);